# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cartesian_control_msgs/CartesianTolerance.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class CartesianTolerance(genpy.Message):
  _md5sum = "af7b81a920293904e6a5480495adb8d1"
  _type = "cartesian_control_msgs/CartesianTolerance"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Vector3 position_error
geometry_msgs/Vector3 orientation_error
geometry_msgs/Twist twist_error
geometry_msgs/Accel acceleration_error

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Accel
# This expresses acceleration in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular
"""
  __slots__ = ['position_error','orientation_error','twist_error','acceleration_error']
  _slot_types = ['geometry_msgs/Vector3','geometry_msgs/Vector3','geometry_msgs/Twist','geometry_msgs/Accel']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       position_error,orientation_error,twist_error,acceleration_error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CartesianTolerance, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.position_error is None:
        self.position_error = geometry_msgs.msg.Vector3()
      if self.orientation_error is None:
        self.orientation_error = geometry_msgs.msg.Vector3()
      if self.twist_error is None:
        self.twist_error = geometry_msgs.msg.Twist()
      if self.acceleration_error is None:
        self.acceleration_error = geometry_msgs.msg.Accel()
    else:
      self.position_error = geometry_msgs.msg.Vector3()
      self.orientation_error = geometry_msgs.msg.Vector3()
      self.twist_error = geometry_msgs.msg.Twist()
      self.acceleration_error = geometry_msgs.msg.Accel()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_18d().pack(_x.position_error.x, _x.position_error.y, _x.position_error.z, _x.orientation_error.x, _x.orientation_error.y, _x.orientation_error.z, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.acceleration_error.linear.x, _x.acceleration_error.linear.y, _x.acceleration_error.linear.z, _x.acceleration_error.angular.x, _x.acceleration_error.angular.y, _x.acceleration_error.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.position_error is None:
        self.position_error = geometry_msgs.msg.Vector3()
      if self.orientation_error is None:
        self.orientation_error = geometry_msgs.msg.Vector3()
      if self.twist_error is None:
        self.twist_error = geometry_msgs.msg.Twist()
      if self.acceleration_error is None:
        self.acceleration_error = geometry_msgs.msg.Accel()
      end = 0
      _x = self
      start = end
      end += 144
      (_x.position_error.x, _x.position_error.y, _x.position_error.z, _x.orientation_error.x, _x.orientation_error.y, _x.orientation_error.z, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.acceleration_error.linear.x, _x.acceleration_error.linear.y, _x.acceleration_error.linear.z, _x.acceleration_error.angular.x, _x.acceleration_error.angular.y, _x.acceleration_error.angular.z,) = _get_struct_18d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_18d().pack(_x.position_error.x, _x.position_error.y, _x.position_error.z, _x.orientation_error.x, _x.orientation_error.y, _x.orientation_error.z, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.acceleration_error.linear.x, _x.acceleration_error.linear.y, _x.acceleration_error.linear.z, _x.acceleration_error.angular.x, _x.acceleration_error.angular.y, _x.acceleration_error.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.position_error is None:
        self.position_error = geometry_msgs.msg.Vector3()
      if self.orientation_error is None:
        self.orientation_error = geometry_msgs.msg.Vector3()
      if self.twist_error is None:
        self.twist_error = geometry_msgs.msg.Twist()
      if self.acceleration_error is None:
        self.acceleration_error = geometry_msgs.msg.Accel()
      end = 0
      _x = self
      start = end
      end += 144
      (_x.position_error.x, _x.position_error.y, _x.position_error.z, _x.orientation_error.x, _x.orientation_error.y, _x.orientation_error.z, _x.twist_error.linear.x, _x.twist_error.linear.y, _x.twist_error.linear.z, _x.twist_error.angular.x, _x.twist_error.angular.y, _x.twist_error.angular.z, _x.acceleration_error.linear.x, _x.acceleration_error.linear.y, _x.acceleration_error.linear.z, _x.acceleration_error.angular.x, _x.acceleration_error.angular.y, _x.acceleration_error.angular.z,) = _get_struct_18d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_18d = None
def _get_struct_18d():
    global _struct_18d
    if _struct_18d is None:
        _struct_18d = struct.Struct("<18d")
    return _struct_18d
